'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouter = require('react-router');

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListenerRouter = function (_Component) {
	_inherits(ListenerRouter, _Component);

	function ListenerRouter() {
		_classCallCheck(this, ListenerRouter);

		return _possibleConstructorReturn(this, _Component.apply(this, arguments));
	}

	ListenerRouter.prototype.componentWillMount = function componentWillMount() {
		var _props = this.props,
		    propsStore = _props.store,
		    history = _props.history;

		this.store = propsStore || this.context.store;
		var dispatch = this.store.dispatch;


		var conn = _http2.default.createServer(function (req, res) {
			req.on('data', function (chunk) {
				dispatch((0, _actions.onMessage)({ data: chunk.toString(), url: req.url }));
			});

			res.writeHead(200, { 'Content-Type': 'application/json' });
			res.end();
		}).listen('4545', 'localhost');

		dispatch({ type: _actions.CREATE_CONNECTION, payload: conn });
	};

	ListenerRouter.prototype.render = function render() {
		console.log(this.store.getState());
		return _react2.default.createElement('div', null);
	};

	return ListenerRouter;
}(_react.Component);

ListenerRouter.propTypes = {
	store: _propTypes2.default.object,
	children: _propTypes2.default.node
};
ListenerRouter.contextTypes = {
	store: _propTypes2.default.object
};
exports.default = ListenerRouter;