(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('http'), require('prop-types'), require('react-router')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react', 'http', 'prop-types', 'react-router'], factory) :
	(factory((global.ReactRouterApi = {}),global.React,global.http,global.PropTypes,global.ReactRouter));
}(this, (function (exports,React,http,PropTypes,reactRouter) { 'use strict';

var React__default = 'default' in React ? React['default'] : React;
http = http && http.hasOwnProperty('default') ? http['default'] : http;
PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;

var CREATE_CONNECTION = '@@connection/CREATE_CONNECTION';
var ON_MESSAGE = '@@connection/ON_MESSAGE';

var onMessage = function onMessage(data) {
	return { type: ON_MESSAGE, payload: data };
};

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListenerRouter = function (_Component) {
	_inherits(ListenerRouter, _Component);

	function ListenerRouter() {
		_classCallCheck(this, ListenerRouter);

		return _possibleConstructorReturn(this, _Component.apply(this, arguments));
	}

	ListenerRouter.prototype.componentWillMount = function componentWillMount() {
		var _props = this.props,
		    propsStore = _props.store,
		    history = _props.history;

		this.store = propsStore || this.context.store;
		var dispatch = this.store.dispatch;


		var conn = http.createServer(function (req, res) {
			req.on('data', function (chunk) {
				dispatch(onMessage({ data: chunk.toString(), url: req.url }));
			});

			res.writeHead(200, { 'Content-Type': 'application/json' });
			res.end();
		}).listen('4545', 'localhost');

		dispatch({ type: CREATE_CONNECTION, payload: conn });
	};

	ListenerRouter.prototype.render = function render() {
		console.log(this.store.getState());
		return React__default.createElement('div', null);
	};

	return ListenerRouter;
}(React.Component);

ListenerRouter.propTypes = {
	store: PropTypes.object,
	children: PropTypes.node
};
ListenerRouter.contextTypes = {
	store: PropTypes.object
};

function listenerReducer() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
	    type = _ref.type,
	    payload = _ref.payload;

	if (type === CREATE_CONNECTION) return Object.assign({}, state, { c: payload });
	if (type === ON_MESSAGE) {
		return Object.assign({}, state, { onMessage: payload.data });
	}
	return state;
}

function listenerMiddleware() {
  return function () {
    return function (next) {
      return function (action) {
        next(action);
      };
    };
  };
}

//maybe we'll need this, i'm not sure

exports.ListenerRouter = ListenerRouter;
exports.listenerMiddleware = listenerMiddleware;
exports.onMessage = onMessage;
exports.ON_MESSAGE = ON_MESSAGE;
exports.CREATE_CONNECTION = CREATE_CONNECTION;
exports.listenerReducer = listenerReducer;

Object.defineProperty(exports, '__esModule', { value: true });

})));
